import argparse
import datetime
from datetime import time
from datetime import date

today = date.today()


def constructDate(uur, minuten):
    enter = time(uur, minuten)
    return enter


def calculateLeave(enter, lunchbreak):
    leave = (datetime.datetime.combine(today, enter) + datetime.timedelta(hours=7, minutes=48)).time()
    normal = datetime.datetime.combine(today, leave)
    exit = normal + datetime.timedelta(minutes=lunchbreak)
    return exit


def main():
    now = datetime.datetime.now()
    parser = argparse.ArgumentParser(description="IK WIL NAAR HUIS")
    parser.add_argument('-t', '--time', nargs="+", metavar='T', type=int,
                        help='the time you started working in hours, optional')
    parser.add_argument("-l", "--lunch", metavar='L', type=int, required=False,
                        dest="lunch", help="Enter your lunch break in minutes.")

    args = parser.parse_args()

    if args.time == None:
        # if run with no integers then we use the script execution time as starting moment of the day
        start_hour = now.hour
        start_minutes = now.minute
        print("Script executed without specified time, using current time of day.")

    else:
        # try to parse an hour out of two integers
        # first integer is always interpreted as an hour
        # second integer is always interpreted as minutes
        # if not second integer, we use minutes = 0
        start_hour = args.time[0]
        try:
            start_minutes = args.time[1]
        except:
            start_minutes = 0

        # -l or --lunch is optional parameter for specifing your lunch break duration, 60 minutes default.

    print("Your starting time is {} : {}.".format(
        start_hour, str(start_minutes).zfill(2)))

    lunch = 60

    if args.lunch == None:
        print("No --lunch specified, using default of {} minutes.".format(lunch))
        pass

    else:
        lunch = args.lunch
        print("Specified --lunch break of {} minutes".format(lunch))

        pass

    enter = constructDate(start_hour, start_minutes)
    leave = calculateLeave(enter, lunch)

    print("You are allowed to leave at " +
          leave.strftime("%H:%M" + " my fren."))


if __name__ == "__main__":
    main()
